
/**
 * An interface representing a Binary Tree. Includes methods for navigating through subtrees.
 * 
 * @author Joel
 * @version Fa 2014
 */
public interface AbstractBinaryTree<E>
{
	/**
	 * Returns the data at the root of this binary tree
	 * @return the data at the root of the tree
	 */
	public E getData();

	/**
	 * Returns whether or not the tree is a leaf (has only a single element)
	 * @return whether or not the tree is a leaf
	 */
	public boolean isLeaf();

	/**
	 * Returns the left subtree of this tree
	 * @return the left subtree
	 */
	public AbstractBinaryTree<E> getLeftSubTree();

	/**
	 * Returns the right subtree of this tree
	 * @return the right subtree
	 */
	public AbstractBinaryTree<E> getRightSubTree();
	
}
