import java.util.ArrayList;
import java.util.TreeMap;

/**
 * A class that is able to encode and decode Strings using Huffman encoding.
 * 
 * @author YOUR_NAME_HERE
 */
public class HuffmanStringCodec
{
	private AbstractHuffmanTree<Character> huffTree; //the Huffman tree representing the encoding of this codec

	/**
	 * Constructs a new codec object
	 */
	public HuffmanStringCodec()
	{
		huffTree = null;
	}

	
	/**
	 * Creates an encoding tree using the frequencies of the letters in the given input String
	 * @param input A string used to form the basis of the Huffman encoding
	 */
	public void createTree(String input)
	{
		TreeMap<Character, Integer> frequencies = new TreeMap<Character, Integer>();
		
		for(int i=0; i<input.length(); i++)
		{
			char c = input.charAt(i);
			Integer freq = frequencies.get(c);
			if(freq == null)
				freq = 0;
			frequencies.put(c,freq+1);
		}
		
		huffTree = new HuffmanTree<Character>(frequencies);
	}
	

	/**
	 * Encodes the given input using the Huffman encoding of the current tree. Returns a bit string representation of that input
	 * @param input The String to encode
	 * @return a bitstring representation of the encoded String
	 */
	public String encode(String input)
	{
		//TODO FILL THIS IN!
		
		return null;
	}
	
	
	/**
	 * Decodes the given bit string, returning the raw String
	 * @param bitString a bitString to decode
	 * @return The "decoded" version of that bitstring, per the current Huffman tree
	 */
	public String decode(String bitString)
	{
		//TODO FILL THIS IN!
		
		return "";
	}

	
	/**
	 * Returns a String representation of the codec's current encoding function (e.g., of the Huffman tree)
	 * @return A String showing the encoding function of the current Huffman Tree
	 */
	public String getEncoding()
	{
		if(huffTree == null)
			throw new IllegalStateException("Huffman tree has not been created; no encoding exists");
		
		return huffTree.getCodeList();
	}	
}
